/* rijn2 permet de crypter un fichier zip en un fichier bin (code 'c', 'e')   */
/*              de dcrypter un fichier bin en un fichier zip (code 'd')      */
/*    1er argument = code c, C (Crypter), e, E (Encrypt), d, D (Decrypter)    */
/*    2eme arg = fichier input                                                */
/*                (fichier output -> input auquel on aura chang l'extension) */
/*    3eme arg = clef                                                         */
/*    4eme (optionnel dans le cas du decryptage)                              */
/*             = iv                                                           */
/*      (si n'existe pas == 16 (ou 32 si hexa) premiers caractres du fichier */
#include "fullSpec.h"
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <dir.h>
#include <mem.h>
/*
#include "alg-fst.c"
#include "api-fst.c"
#include "encdec.c"
#include "enckeys.c"
#include "encmac.c"
#include "hashcomp.c"
#include "maccomp.c"
*/
extern int makeKeyBinary (keyInstance * keyInst, BYTE direction,
	       unsigned char *cipherKey);
extern int cipherInitBinary (cipherInstance * cipherInst, unsigned char *IV);
extern int encryptData2 (unsigned char *result, cipherInstance * cipherInst,
	     keyInstance * keyInst, unsigned char *plaintext,
	     unsigned long plainLen, int last_block);
extern int decryptData2 (unsigned char *result, cipherInstance * cipherInst,
	     keyInstance * keyInst, unsigned char *ciphertext,
	     unsigned long cipherLen, int last_block);

extern unsigned char decryptedMacKey[100];
extern unsigned char decryptedEncKey[100];

#define IV_FILE_HEXA 0

static unsigned int BLOCK_CRYPT = 16 * 1024;

int handel_Read  = -1;
int handel_Write = -1;

BYTE *point;
BYTE errmsg[100];
/* << 9.03 */
/*BYTE pathlogerr[256];*/
/* >> */
BYTE *cipherData = NULL;

void Erreur2(char *);
Rstr(char *chaine);

int Decrypt_File(char *, char *, BYTE *, BYTE *);
int Encrypt_File(char *, char *, BYTE *, BYTE *);
int Get_IV_From_File(char *, BYTE *, int);
void Hexa_To_Byte(char *, BYTE *);
void Read_Param(int, char **, char *, char *, char *, char *);

/******************************/
int rijn2(int argc, char **argv)
/******************************/
{
  char code[2];
  char filename_input[256];
  char filename_output[256];
  char KEY_HEXA[33];
  char IV_HEXA[33];
  BYTE key[17];
  BYTE iv[17];
  char drive[8];
  char dir[256];
  char file[16];
  char ext[8];
  FILE *fps;

  /* Debug */
  point = errmsg;

  /* Read_Param */
  memset(code, 0, sizeof(code));
  memset(filename_input, 0, sizeof(filename_input));
  memset(filename_output, 0, sizeof(filename_output));
  memset(KEY_HEXA, 0, sizeof(KEY_HEXA));
  memset(IV_HEXA, 0, sizeof(IV_HEXA));
  memset(key, 0, sizeof(key));
  memset(iv,  0, sizeof(iv));

  Read_Param(argc, argv, code, filename_input, KEY_HEXA, IV_HEXA);
  fnsplit(filename_input, drive, dir, file, ext);
  
  /* << 9.03 */
  /* pathlogerr */
  /*fnmerge(pathlogerr, drive, dir, "log", ".err");
  unlink(pathlogerr);*/
  /* Creation du fichier log.err
     Si tout se passe bien, sera detruit */
  /*if ((fps = fopen(pathlogerr,"a")) != NULL)
  {
    fputs("Problem with rijn2\n",fps);
    fclose(fps);
  }*/
  /* >> */
  /*printf("code: %s\n", code);
  printf("filename_input: %s\n", filename_input);
  printf("filename_output: %s\n", filename_output);
  printf("KEY_HEXA: %s\n", KEY_HEXA);
  printf("IV_HEXA: %s\n", IV_HEXA);*/

/*
  Hexa_To_Byte(KEY_HEXA, key);
  if(IV_HEXA[0]) Hexa_To_Byte(IV_HEXA, iv);
*/
  memcpy(iv, decryptedMacKey, 16);
  memcpy(key, decryptedEncKey, 16);

  /*printf("key: [%s] -> [%s]\n", KEY_HEXA, key);
  printf("iv:  [%s] -> [%s]\n", IV_HEXA,  iv);*/

  switch(code[0])
  {
    case 'c':
    case 'C': /* 'C'rypt */
    case 'e': /* 'E'ncrypt */
    case 'E': /* fichier source .zip -> fichier crypt .bin */
      /* IV */
      if(!iv[0]) /* Get from file */
      {
        /*if(!IV_FILE_HEXA)*/
          if(Get_IV_From_File(filename_input, iv, 16) == -1)
            return -1;
        /*else
        {
          Get_IV_From_File(filename_input, IV_HEXA, 32);
          Hexa_To_Byte(IV_HEXA, iv);
        }*/
      }
      /* filename_output */
      fnmerge(filename_output, drive, dir, file, ".crp");
      if(Encrypt_File(filename_input, filename_output, key, iv) == -1)
        return -1;
      break;
    case 'd':
    case 'D': /* fichier crypt .bin -> fichier decrypt .zip */
      /* filename_output */
      /* filename_output */
      fnmerge(filename_output, drive, dir, file, "");
      if(Decrypt_File(filename_input, filename_output, key, iv) == -1)
        return -1;
      break;
  }

  /* << 9.03 */
  /* No problem delete log.err */
  /*unlink(pathlogerr);*/
  /* >> */
 return(1);
}

/***********************/
void Erreur2(char *msg)
/***********************/
{
  FILE *fp;
  if ((fp = fopen("a:\\LOG.ERR","a")) != NULL)
  {
    fputs(msg,fp);
    fclose(fp);
  }

  /* Fermeture des fichiers succeptibles d'etre restes ouverts */
  if(handel_Read != -1)
    close(handel_Read);

  if(handel_Write != -1)
    close(handel_Write);
}

/*****************************************************************************/
int Encrypt_File(char *_input, char *_output, BYTE *_key, BYTE *_iv)
/*****************************************************************************/
{
  unsigned long cipherDataLen,plainDataLen;
  register int Carry;
  keyInstance encKeyInst;       /* state of the decryption engine */
  cipherInstance encCipherInst; /* specifies the decryption mode */
  int stat;
  int last_block;
  unsigned int i, iCptSplit;
  unsigned long cipherDataLenOri;

  last_block = 0;

  stat = makeKeyBinary (&encKeyInst, DIR_ENCRYPT, _key);
  if(stat != 0)
  {
    sprintf(errmsg,"Fichier %s\n\tErreur makeKeyBinary\n",_input);
    Erreur2(point);
    return -1;
  }
  stat = cipherInitBinary (&encCipherInst, _iv);
  if(stat != 0)
  {
    sprintf(errmsg,"Fichier %s\n\tErreur cipherInitBinary\n",_input);
    Erreur2(point);
    return -1;
  }

  /* Lecture du fichier  crypter */
  handel_Read = open(_input, O_RDWR | O_BINARY,0x0100 | 0x0080);
  if(handel_Read == -1)
  {
    sprintf(errmsg,"Erreur d'ouverture du fichier %s\n",_input);
    Erreur2(point);
    return -1;
  }
  cipherDataLen = /*(int)*/filelength(handel_Read);

  iCptSplit = 1;
  if(cipherDataLen > BLOCK_CRYPT)
  {
    cipherDataLenOri = cipherDataLen;
    iCptSplit += (int)(cipherDataLenOri / BLOCK_CRYPT);
    if(((unsigned long)iCptSplit-1)*(unsigned long)BLOCK_CRYPT == cipherDataLenOri)
    {
      BLOCK_CRYPT += 16;
      iCptSplit = 1 + (int)(cipherDataLenOri / BLOCK_CRYPT);
    }
  }

  /* _output */
  unlink(_output);
  handel_Write = open(_output,O_CREAT | O_APPEND | O_BINARY,0x0100 | 0x0080);
  if(handel_Write == -1)
  {
    sprintf(errmsg,"Erreur d'ouverture du fichier %s\n",_output);
    Erreur2(point);
    return -1;
  }

  cipherData = malloc(BLOCK_CRYPT);
  for(i=0; i<iCptSplit; ++i)
  {
    if(iCptSplit > 1)
    {
      if(i != iCptSplit-1)
        cipherDataLen = BLOCK_CRYPT;
      else
        cipherDataLen = cipherDataLenOri - i * BLOCK_CRYPT;
    }
    cipherData[0] = 0x00;
    cipherDataLen = read(handel_Read,cipherData,cipherDataLen);
    if(cipherDataLen == -1)
    {
      sprintf(errmsg,"Erreur de lecture du fichier %s\n",_input);
      Erreur2(point);
      return -1;
    }
    if(i==iCptSplit-1)
      last_block = 1;
    stat = encryptData2(cipherData, &encCipherInst, &encKeyInst,
                        cipherData, cipherDataLen, last_block);
    if (stat < 0)
    {
      sprintf(errmsg,"encryption routine returns error code <%i>\n", stat);
      Erreur2(point);
      return -1;
    }

    if(!last_block)
      Carry = write(handel_Write,cipherData,cipherDataLen);
    else
    {
      Carry = write(handel_Write,cipherData,stat);
      cipherDataLen = stat;
    }

    if(Carry != cipherDataLen)
    {
      sprintf(errmsg,"Erreur d'criture du fichier %s\n",_output);
      Erreur2(point);
      return -1;
    }
  }
  free(cipherData);
  close(handel_Read); handel_Read = -1;
  close(handel_Write); handel_Write = -1;

  return 1;
}


/*****************************************************************************/
int Decrypt_File(char *_input, char *_output, BYTE *_key, BYTE *_iv)
/*****************************************************************************/
{
  unsigned long cipherDataLen,plainDataLen;
  register int Carry;
  keyInstance decKeyInst;       /* state of the decryption engine */
  cipherInstance decCipherInst; /* specifies the decryption mode */
  int stat;
  int last_block;
  unsigned int i, iCptSplit;
  unsigned long cipherDataLenOri;

  last_block = 0;

  stat = makeKeyBinary (&decKeyInst, DIR_DECRYPT, _key);
  if(stat != 0)
  {
    sprintf(errmsg,"Fichier %s\n\tErreur makeKeyBinary\n",_input);
    Erreur2(point);
    return -1;
  }
  stat = cipherInitBinary (&decCipherInst, _iv);
  if(stat != 0)
  {
    sprintf(errmsg,"Fichier %s\n\tErreur cipherInitBinary\n",_input);
    Erreur2(point);
    return -1;
  }

  /* Lecture du fichier  crypter */
  handel_Read = open(_input, O_RDWR | O_BINARY,0x0100 | 0x0080);
  if(handel_Read == -1)
  {
    sprintf(errmsg,"Erreur d'ouverture du fichier %s\n",_input);
    Erreur2(point);
    return -1;
  }
  cipherDataLen = /*(int)*/filelength(handel_Read);

  iCptSplit = 1;
  if(cipherDataLen > BLOCK_CRYPT)
  {
    cipherDataLenOri = cipherDataLen;
    iCptSplit += (int)(cipherDataLenOri / BLOCK_CRYPT);
    if(((unsigned long)iCptSplit-1)*(unsigned long)BLOCK_CRYPT == cipherDataLenOri)
    {
      BLOCK_CRYPT += 16;
      iCptSplit = 1 + (int)(cipherDataLenOri / BLOCK_CRYPT);
    }
  }

  /* _output */
  unlink(_output);
  handel_Write = open(_output,O_CREAT | O_APPEND | O_BINARY,0x0100 | 0x0080);
  if(handel_Write == -1)
  {
    sprintf(errmsg,"Erreur d'ouverture du fichier %s\n",_output);
    Erreur2(point);
    return -1;
  }

  cipherData = malloc(BLOCK_CRYPT);
  for(i=0; i<iCptSplit; ++i)
  {
    if(iCptSplit > 1)
    {
      if(i != iCptSplit-1)
        cipherDataLen = BLOCK_CRYPT;
      else
        cipherDataLen = cipherDataLenOri - i * BLOCK_CRYPT;
    }
    cipherData[0] = 0x00;
    cipherDataLen = read(handel_Read,cipherData,cipherDataLen);
    /*printf("cipherDataLen: %d\n", cipherDataLen);*/
    if(cipherDataLen == -1)
    {
      sprintf(errmsg,"Erreur de lecture du fichier %s\n",_input);
      Erreur2(point);
      return -1;
    }

    if(i==iCptSplit-1)
      last_block = 1;

    stat = decryptData2(cipherData, &decCipherInst, &decKeyInst,
                        cipherData, cipherDataLen, last_block);
    if(stat < 0)
    {
      sprintf(errmsg,"decryption routine returns error code <%i>\n", stat);
      Erreur2(point);
      return -1;
    }
    if(last_block)
      cipherDataLen = stat;

    Carry = write(handel_Write,cipherData,cipherDataLen);

    if(Carry != cipherDataLen)
    {
      sprintf(errmsg,"Erreur d'criture du fichier %s\n",_output);
      Erreur2(point);
      return -1;
    }
  }
  free(cipherData);
  close(handel_Read); handel_Read = -1;
  close(handel_Write); handel_Write = -1;

  return 1;
}

/***************************************/
void Read_Param(int _argc, char **_argv,
                char *_code,
                char *_filename,
                char *_KEY_HEXA,
                char *_IV_HEXA)
/***************************************/
{
  /* _code */
  if(_argc >= 2) strcpy(_code, _argv[1]);
  /* _filename_to_encrypt */
  if(_argc >= 3) strcpy(_filename, _argv[2]);
  /* _KEY_HEXA */
  if(_argc >= 4) strcpy(_KEY_HEXA, _argv[3]);
  /* _IV_HEXA */
  if(_argc >= 5) strcpy(_IV_HEXA, _argv[4]);
}

/*****************************************************************************/
void Hexa_To_Byte(char *_in, BYTE *_out)
/*****************************************************************************/
{
  BYTE Bffer[100],C1,C2;
  int i,j,n,Carry;

  strcpy(Bffer,_in);

  for ( i = 0 ; i <  64 ; i++)
  {
    if(Bffer[i] < 58) Bffer[i] -= 48;
    else              Bffer[i] -= 55;
  }

  for(i = 0, j = 0; j < 32 / 2; j++)
  {
    _out[j]   = Bffer[i++] << 4;
    _out[j]   = Bffer[i++] | _out[j];
  }
  _out[j] = 0x00;
}

/*****************************************************************************/
int Get_IV_From_File(char *_filename, BYTE *_iv, int _iNbc)
/*****************************************************************************/
{
  int fin, fout;
  BYTE *Bffer = NULL;
  unsigned long Bfferlen;

  /* get iv */
  if((fin = open(_filename, O_RDWR | O_BINARY,0x0100 | 0x0080)) == -1)
  {
    sprintf(errmsg,"error opening %s",_filename);
    Erreur2(point);
    return -1;
  }
  Bfferlen = filelength(fin);
  /*printf("Bfferlen: %ld\n", Bfferlen);*/
  Bffer = malloc(Bfferlen);
  read(fin,Bffer,Bfferlen);
  close(fin);

  /* Remove Iv from file */
  unlink(_filename);
  if((fout = open(_filename, O_CREAT | O_RDWR | O_BINARY,0x0100 | 0x0080)) == -1)
  {
    sprintf(errmsg,"error opening %s",_filename);
    Erreur2(point);
    return -1;
  }
  write(fout,Bffer+_iNbc,Bfferlen-_iNbc);
  close(fout);

  /* iv */
  memcpy(_iv, Bffer, _iNbc);

  return 1;
}
